;***************************
; Aitendo OLED control
;
; ASM routine
;***************************

.include "p24FJ64GA002.inc"

.global _asmCopy
.global _asmWrite

.text

_asmWrite:
	; **** Write W1 value to OLED ****
	MOV		#8,W2
	BSET	LATB,#14		; A0
	BTSS	W0,#0
	BCLR	LATB,#14		; A0
	BCLR	LATB,#15		; CS=L
	;*** LOOP
loop:
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	DEC		W2,W2
	BRA		NZ,loop
	;
	BSET	LATB,#15		; CS=H

	return	

_asmCopy:
	MOV		W0,W3			; Copy address to W3
	MOV		W1,W4			; Copy mask pattern1
	MOV		W2,W5			; Copy mask pattern2
	; ****** 0-7lines ****************
	MOV		#8,W6
	; ****** Command out *************
	BCLR	LATB,#14		; A0 = CMD
	MOV		#0xb0,W1			; 0xb0
	CALL	BYTE_WR			;
	MOV		#0x10,W1			; 0x10
	CALL	BYTE_WR			;
	MOV		#0,W1			; 0x0
	CALL	BYTE_WR			;
		;
	BSET	LATB,#14		; A0 = DATA
loop00:
		MOV		#64,W7
loop0:
		MOV		[W3],W1		; Get display data
		AND		W1,W4,W1	; AND with mask1 (55aa or aa55 or ff00)
		MOV		W1,W2		; Merge higher 8bit with lower 8bit 
		LSR		W2,#8,W2		;
		IOR		W2,W1,W1	; W1 has display data	
		;CALL	BYTE_WR	
			BCLR	LATB,#15		; CS=L
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BSET	LATB,#15		; CS=H
	;
		ADD		W3,#2,W3
		;
		MOV		[W3],W1		; Get display data
		AND		W1,W5,W1	; AND with mask1 (aa55 or 55aa or ff00)
		MOV		W1,W2		; Merge higher 8bit with lower 8bit 
		LSR		W2,#8,W2		;
		IOR		W2,W1,W1	; W1 has display data	
		;CALL	BYTE_WR	
			BCLR	LATB,#15		; CS=L
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BCLR	LATB,#12		; CLK = L
			BSET	LATB,#13		; DAT = H
			BTSS	W1,#7
			BCLR	LATB,#13		; DAT = L
			BSET	LATB,#12		; CLK = H
			RLC		W1,W1			; 1 bit@left shift
	;
			BSET	LATB,#15		; CS=H
	;
		ADD		W3,#2,W3
		;
		DEC		W7,W7
		BRA		NZ,loop0
	DEC		W6,W6
	BRA		NZ,loop00
	;
	return	

	; **** Write W1 value to OLED ****
BYTE_WR:
	BCLR	LATB,#15		; CS=L
	;
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	BCLR	LATB,#12		; CLK = L
	BSET	LATB,#13		; DAT = H
	BTSS	W1,#7
	BCLR	LATB,#13		; DAT = L
	BSET	LATB,#12		; CLK = H
	RLC		W1,W1			; 1 bit@left shift
	;
	BSET	LATB,#15		; CS=H
	return	